unit VidCap;

interface
uses Windows, Messages;

type
  TVIDEOHDR = record
    lpData         : PByte;             // pointer to locked data buffer */
    dwBufferLength : Integer;           // Length of data buffer */
    dwBytesUsed    : Integer;           // Bytes actually used */
    dwTimeCaptured : Integer;           // Milliseconds from start of stream */
    dwUser         : Integer;                 // for client's use */
    dwFlags        : Integer;                // assorted flags (see defines) */
    dwReserved     : array[0..3] of Integer;          // reserved for driver */
  end;
  PVIDEOHDR = ^TVIDEOHDR;

  TCAPTUREPARMS = record
        dwRequestMicroSecPerFrame : DWORD;
	fMakeUserHitOKToCapture   : BOOL;
	wPercentDropForError      : UINT;
	fYield			  : BOOL;
	dwIndexSize               : DWORD;
	wChunkGranularity	  : UINT;
	fUsingDOSMemory		  : BOOL;
	wNumVideoRequested        : UINT;
	fCaptureAudio             : BOOL;
	wNumAudioRequested        : UINT;
	vKeyAbort		  : UINT;
	fAbortLeftMouse		  : BOOL;
	fAbortRightMouse	  : BOOL;
	fLimitEnabled             : BOOL;
	wTimeLimit                : UINT;
	fMCIControl		  : BOOL;
	fStepMCIDevice            : BOOL;
	dwMCIStartTime            : DWORD;

	dwMCIStopTime	          : DWORD;
	fStepCaptureAt2x          : BOOL;
	wStepCaptureAverageFrames : UINT;
	dwAudioBufferSize         : DWORD;
	fDisableWriteCache        : BOOL;
	AVStreamMaster            : UINT;
  end;
  PCAPTUREPARMS = ^TCAPTUREPARMS;
  
const

WM_CAP_START                    = WM_USER;

// start of unicode messages
WM_CAP_UNICODE_START            =WM_USER+100;

WM_CAP_GET_CAPSTREAMPTR         =(WM_CAP_START+  1);

WM_CAP_SET_CALLBACK_ERRORW     =(WM_CAP_UNICODE_START+  2);
WM_CAP_SET_CALLBACK_STATUSW    =(WM_CAP_UNICODE_START+  3);
WM_CAP_SET_CALLBACK_ERRORA     =(WM_CAP_START+  2);
WM_CAP_SET_CALLBACK_STATUSA    =(WM_CAP_START+  3);
WM_CAP_SET_CALLBACK_ERROR      = WM_CAP_SET_CALLBACK_ERRORA;
WM_CAP_SET_CALLBACK_STATUS     = WM_CAP_SET_CALLBACK_STATUSA;

WM_CAP_SET_CALLBACK_YIELD      = (WM_CAP_START+  4);
WM_CAP_SET_CALLBACK_FRAME       =(WM_CAP_START+  5);
WM_CAP_SET_CALLBACK_VIDEOSTREAM =(WM_CAP_START+  6);
WM_CAP_SET_CALLBACK_WAVESTREAM  =(WM_CAP_START+  7);
WM_CAP_GET_USER_DATA		=(WM_CAP_START+  8);
WM_CAP_SET_USER_DATA		=(WM_CAP_START+  9);

WM_CAP_DRIVER_CONNECT           =(WM_CAP_START+  10);
WM_CAP_DRIVER_DISCONNECT        =(WM_CAP_START+  11);

WM_CAP_DRIVER_GET_NAMEA        =(WM_CAP_START+  12);
WM_CAP_DRIVER_GET_VERSIONA     =(WM_CAP_START+  13);
WM_CAP_DRIVER_GET_NAMEW        =(WM_CAP_UNICODE_START+  12);
WM_CAP_DRIVER_GET_VERSIONW     =(WM_CAP_UNICODE_START+  13);
WM_CAP_DRIVER_GET_NAME         = WM_CAP_DRIVER_GET_NAMEA;
WM_CAP_DRIVER_GET_VERSION      = WM_CAP_DRIVER_GET_VERSIONA;

WM_CAP_DRIVER_GET_CAPS         = (WM_CAP_START+  14);

WM_CAP_FILE_SET_CAPTURE_FILEA  =(WM_CAP_START+  20);
WM_CAP_FILE_GET_CAPTURE_FILEA  =(WM_CAP_START+  21);
WM_CAP_FILE_SAVEASA            =(WM_CAP_START+  23);
WM_CAP_FILE_SAVEDIBA           =(WM_CAP_START+  25);
WM_CAP_FILE_SET_CAPTURE_FILEW  =(WM_CAP_UNICODE_START+  20);
WM_CAP_FILE_GET_CAPTURE_FILEW  =(WM_CAP_UNICODE_START+  21);
WM_CAP_FILE_SAVEASW            =(WM_CAP_UNICODE_START+  23);
WM_CAP_FILE_SAVEDIBW           =(WM_CAP_UNICODE_START+  25);
WM_CAP_FILE_SET_CAPTURE_FILE   = WM_CAP_FILE_SET_CAPTURE_FILEA;
WM_CAP_FILE_GET_CAPTURE_FILE   = WM_CAP_FILE_GET_CAPTURE_FILEA;
WM_CAP_FILE_SAVEAS             = WM_CAP_FILE_SAVEASA;
WM_CAP_FILE_SAVEDIB            = WM_CAP_FILE_SAVEDIBA;

WM_CAP_FILE_ALLOCATE           = (WM_CAP_START+  22);
WM_CAP_FILE_SET_INFOCHUNK      = (WM_CAP_START+  24);

WM_CAP_EDIT_COPY               = (WM_CAP_START+  30);

WM_CAP_SET_AUDIOFORMAT         = (WM_CAP_START+  35);
WM_CAP_GET_AUDIOFORMAT         = (WM_CAP_START+  36);

WM_CAP_DLG_VIDEOFORMAT         = (WM_CAP_START+  41);
WM_CAP_DLG_VIDEOSOURCE         = (WM_CAP_START+  42);
WM_CAP_DLG_VIDEODISPLAY        = (WM_CAP_START+  43);
WM_CAP_GET_VIDEOFORMAT         = (WM_CAP_START+  44);
WM_CAP_SET_VIDEOFORMAT         = (WM_CAP_START+  45);
WM_CAP_DLG_VIDEOCOMPRESSION    = (WM_CAP_START+  46);

WM_CAP_SET_PREVIEW             = (WM_CAP_START+  50);
WM_CAP_SET_OVERLAY             = (WM_CAP_START+  51);
WM_CAP_SET_PREVIEWRATE         = (WM_CAP_START+  52);
WM_CAP_SET_SCALE               = (WM_CAP_START+  53);
WM_CAP_GET_STATUS              = (WM_CAP_START+  54);
WM_CAP_SET_SCROLL              = (WM_CAP_START+  55);

WM_CAP_GRAB_FRAME              = (WM_CAP_START+  60);
WM_CAP_GRAB_FRAME_NOSTOP       = (WM_CAP_START+  61);

WM_CAP_SEQUENCE                = (WM_CAP_START+  62);
WM_CAP_SEQUENCE_NOFILE         = (WM_CAP_START+  63);
WM_CAP_SET_SEQUENCE_SETUP      = (WM_CAP_START+  64);
WM_CAP_GET_SEQUENCE_SETUP      = (WM_CAP_START+  65);

WM_CAP_SET_MCI_DEVICEA        = (WM_CAP_START+  66);
WM_CAP_GET_MCI_DEVICEA        = (WM_CAP_START+  67);
WM_CAP_SET_MCI_DEVICEW        = (WM_CAP_UNICODE_START+  66);
WM_CAP_GET_MCI_DEVICEW        = (WM_CAP_UNICODE_START+  67);
WM_CAP_SET_MCI_DEVICE         =  WM_CAP_SET_MCI_DEVICEA;
WM_CAP_GET_MCI_DEVICE         =  WM_CAP_GET_MCI_DEVICEA;

WM_CAP_STOP                    = (WM_CAP_START+  68);
WM_CAP_ABORT                   = (WM_CAP_START+  69);

WM_CAP_SINGLE_FRAME_OPEN       = (WM_CAP_START+  70);
WM_CAP_SINGLE_FRAME_CLOSE      = (WM_CAP_START+  71);
WM_CAP_SINGLE_FRAME            = (WM_CAP_START+  72);

WM_CAP_PAL_OPENA              = (WM_CAP_START+  80);
WM_CAP_PAL_SAVEA              = (WM_CAP_START+  81);
WM_CAP_PAL_OPENW              = (WM_CAP_UNICODE_START+  80);
WM_CAP_PAL_SAVEW              = (WM_CAP_UNICODE_START+  81);
WM_CAP_PAL_OPEN               =  WM_CAP_PAL_OPENA;
WM_CAP_PAL_SAVE               =  WM_CAP_PAL_SAVEA;

WM_CAP_PAL_PASTE               = (WM_CAP_START+  82);
WM_CAP_PAL_AUTOCREATE          = (WM_CAP_START+  83);
WM_CAP_PAL_MANUALCREATE        = (WM_CAP_START+  84);

// Following added post VFW 1.1
WM_CAP_SET_CALLBACK_CAPCONTROL = (WM_CAP_START+  85);

// Defines end of the message range
WM_CAP_UNICODE_END             = WM_CAP_PAL_SAVEW;
WM_CAP_END                     = WM_CAP_UNICODE_END;
VidCap32 = 'avicap32.dll';

function capCreateCaptureWindow(
        lpszWindowName:PChar;
        dwStyle:Integer;
        x, y, nWidth, nHeight:Integer;
        hwndParent:HWND; nID:Integer):HWND; stdcall;

function capGetDriverDescription(nDriverIndex:Integer; lpszName:PChar; cbName:Integer; lpszVar:PChar; cbVar:Integer):boolean; stdcall;

implementation

function capCreateCaptureWindow(
        lpszWindowName:PChar;
        dwStyle:Integer;
        x, y, nWidth, nHeight:Integer;
        hwndParent:HWND; nID:Integer):HWND; stdcall; external VidCap32 name 'capCreateCaptureWindowA';

function capGetDriverDescription(nDriverIndex:Integer; lpszName:PChar; cbName:Integer; lpszVar:PChar; cbVar:Integer):boolean; stdcall; external vidCap32 name 'capGetDriverDescriptionA';
end.
