program Vizer;

uses Windows, messages,  VidCap;

const N = 7; // ""       ,   
      N1 = N-1;
      Nkv = N*N;
      Nd2 = N div 2;
      ImageWidth  = 640;  //  .    3    4
      ImageHeight = 480;  //  
      ImageWidthMN = ImageWidth-N;
      ImageHeightMN = ImageHeight-N;
      
type
  TColorImage = array[0..ImageHeight-1,0..ImageWidth-1,0..2] of Byte;
  TBWImage = array[0..ImageHeight-1,0..ImageWidth-1] of Byte;

  TBitmapInfo256 = record
   bmiHeader: TBitmapInfoHeader;
   bmiColors: array[0..255,0..3] of Byte;
  end;

var
  MainWND: thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg: TMsg;
  grt: trect;
  t1,t2,t3:int64;
  VideoWND: HWND;
  ColorImage: TColorImage; //      
  BWImage: TBWImage;    //     - 
  BitmapInfo256: TBitmapInfo256;
  BitmapInfo: TBitmapInfo absolute BitmapInfo256; // BitmapInfo  BitmapInfo256     
  trig: boolean=true;
  Thr: longword;
  info: array [0..ImageHeight-N,0..ImageWidth-N] of integer;

procedure VideoCallback(Wnd:HWND; Hdr:PVIDEOHDR); stdcall;
begin
 Move(Hdr.lpData^, ColorImage, Hdr.dwBytesUsed);
end;

procedure InitBitmapInfo;
 var i:integer;
begin
 Fillchar(BitmapInfo256,sizeof(TBitmapInfoHeader),0);
 BitmapInfo256.bmiHeader.biSize:=40;
 BitmapInfo256.bmiHeader.biPlanes:=1;
 BitmapInfo256.bmiHeader.biWidth:=ImageWidth;
 BitmapInfo256.bmiHeader.biHeight:=ImageHeight;
 for i:=0 to 255 do begin
  BitmapInfo256.bmiColors[i,0]:=i;
  BitmapInfo256.bmiColors[i,1]:=i;
  BitmapInfo256.bmiColors[i,2]:=i;
  BitmapInfo256.bmiColors[i,3]:=0;
 end;
end;

procedure DrawColorImage(var Image:TColorImage);
 var DC:HDC;
begin
 DC:=getdc(mainwnd);
 BitmapInfo.bmiHeader.biBitCount:=24;
 SetDIBitsToDevice(DC,0,0,ImageWidth,ImageHeight,0,0,0,ImageHeight,@Image,BitmapInfo,DIB_RGB_COLORS);
 releasedc(mainwnd,DC);
end;

procedure DrawBWImage(var Image:TBWImage);
 var DC:HDC;
begin
 DC:=getdc(mainwnd);
 BitmapInfo.bmiHeader.biBitCount:=8;
 SetDIBitsToDevice(DC,0,0,ImageWidth,ImageHeight,0,0,0,ImageHeight,@Image,BitmapInfo,DIB_RGB_COLORS);
 releasedc(mainwnd,DC);
end;

procedure FilterBWImage(var Image : TBWImage); assembler;
asm
     PUSH    EDI
     MOV     EDI,EAX
     ADD     EDI,1+ImageWidth
     MOV     ECX,ImageHeight-2

@@1: PUSH    ECX
     PUSH    EDI

     MOV     ECX,ImageWidth-2

@@2: XOR     EAX,EAX
     MOV     AL,[EDI-ImageWidth-1]
     ADD     AL,[EDI-ImageWidth]
     ADC     AH,0
     ADD     AL,[EDI-ImageWidth+1]
     ADC     AH,0
     ADD     AL,[EDI-1]
     ADC     AH,0
     ADD     AL,[EDI]
     ADC     AH,0
     ADD     AL,[EDI+1]
     ADC     AH,0
     ADD     AL,[EDI+ImageWidth-1]
     ADC     AH,0
     ADD     AL,[EDI+ImageWidth]
     ADC     AH,0
     SHR     EAX,3
     STOSB

     LOOP    @@2
     POP     EDI
     POP     ECX
     ADD     EDI,ImageWidth
     LOOP    @@1

     POP     EDI
end;

procedure ColorImageToBWImage(const ColorImage : TColorImage; var BWImage:TBWImage); assembler;
asm
     PUSH     EDI
     PUSH     ESI
     PUSH     EBX

     MOV      EDI,EDX
     MOV      ESI,EAX
     MOV      ECX,ImageHeight*ImageWidth
     MOV      EBX,3

@@2: XOR      EAX,EAX
     LODSB
     MOV      EDX,EAX
     LODSB
     ADD      EDX,EAX
     LODSB
     ADD      EAX,EDX
     DIV      BL

     STOSB
     LOOP     @@2

     POP      EBX
     POP      ESI
     POP      EDI
end;

procedure MonoImage(var Image: TBWImage);
 var i,j,k,m:integer;
begin
 for i:=0 to ImageWidthMN do begin  //    -  - -
  info[0,i]:=0;
  for j:=0 to N1 do info[0,i]:=info[0,i]+Image[j,i];
 end;     

 for j:=1 to ImageHeightMN do  //    
  for i:=0 to ImageWidthMN do
   info[j,i]:=info[j-1,i]-Image[j-1,i]+Image[j+N1,i]; //        

 for j:=Nd2 to ImageHeight-Nd2 do begin
  k:=0;
  for m:=0 to N1 do k:=k+info[j-Nd2,m]; //      
  if Image[j,Nd2]<(k div Nkv) then Image[j,Nd2]:=0 else Image[j,Nd2]:=255;
  
  for i:=Nd2+1 to ImageWidth-Nd2 do begin     // -      
   k:=k+info[j-Nd2,i+Nd2]-info[j-Nd2,i-Nd2-1];
   if Image[j,i]<(k div Nkv) then Image[j,i]:=0 else Image[j,i]:=255;
  end;
 end;
end;

procedure CalcProc;
 var x,y:extended;
begin
 x:=0;
 y:=0;
 while trig do begin
  if VideoWND<>0 then begin
   SendMessage(VideoWND,WM_CAP_GRAB_FRAME_NOSTOP,0,0);
  end;
  queryperformancecounter(t1);
  ColorImageToBWImage(ColorImage,BWImage);
  FilterBWImage(BWImage);
  MonoImage(BWImage);
  queryperformancecounter(t2);
  DrawBWImage(BWImage);
 // DrawColorImage(ColorImage);
  x:=x+(t2-t1)/t3;
  y:=y+1;
 // setwindowtext(mainwnd,pchar(floattostr(x/y)+' sec'));
 // setwindowtext(mainwnd,pchar(floattostr(t3/(t2-t1))+' FPS'));
 end;
end;

function WindowProc(Wnd:HWND; Msg:Integer; wParam:wParam; lParam:lParam):Longint; stdcall;
begin
 case Msg of
  WM_DESTROY:begin
   trig:=false;
   sleep(100);
   DeleteObject(hFontBold);
   unregisterclass('VizerTestKlass',hinstance);
   postquitmessage(0);
   Result:=0;
  end;
 else
  Result:=DefWindowProc(Wnd, Msg, wParam, lParam);
 end;
end;

BEGIN
 hFontBold:=CreateFont(8,0,0,0,0,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,'MS Sans Serif');
 WC.lpfnWndProc:=@WindowProc;
 WC.hicon:=loadicon(hinstance,'MAINICON');
 WC.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=5;
 WC.lpszClassName:='VizerTestKlass';
 RegisterClass(WC);
 systemparametersinfo(spi_getworkarea, 0, @grt, 0);
 MainWND:=CreateWindow('VizerTestKlass',' Vizer',WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX,
       (grt.Right-grt.Left-824) div 2,5,649,508,0,0,hInstance, nil);

 InitBitmapInfo;
 VideoWND:=capCreateCaptureWindow('',WS_CHILD,0,0,ImageWidth,ImageHeight,MainWnd,0);
 if VideoWND<>0 then begin
  if SendMessage(VideoWND,WM_CAP_DRIVER_CONNECT,0,0)=0 then begin
   DestroyWindow(VideoWND);
   VideoWND:=0;
   exit;
  end;
  //   .   BitmapInfo   InitBitmapInfo
  BitmapInfo.bmiHeader.biBitCount:=24;
  SendMessage(VideoWND,WM_CAP_SET_VIDEOFORMAT ,0,Integer(@BitmapInfo));
  SendMessage(VideoWND,WM_CAP_SET_CALLBACK_FRAME ,0,Integer(@VideoCallback));
  SendMessage(VideoWND,WM_CAP_SET_OVERLAY,1,0);   //  
 end;

 queryperformancefrequency(t3);
 CreateThread(nil,0,@CalcProc,nil,0,Thr);
// SendMessage(VideoWND,WM_CAP_DLG_VIDEOSOURCE,0,0);

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
